Description

This patch replaces all occurrences of Date.today with User.current.today.

Date.today always returns the date according to the server's local time zone, leading to all sorts of edge cases that occur more or
less often depending on how large the offset between a user's timezone and the server timezone is. A test case illustrating the

problem using Issue#overdue? as an example is included.

The patch was extracted from Planio and also includes the changes proposed earlier by Holger Just in #20473, with the addition of

two test cases to cover the date manipulation changes in Query#date_clause.

Related issues:

Related to Redmine - Defect #16482: Wrong search query for timelog, when time... New
Related to Redmine - Defect #23189: Spent time by filter, offset by one day New
Related to Redmine - Feature #6470: timezone adjust start/due date Closed
Has duplicate Redmine - Patch #20473: Respect the user's timezone when queryi... Closed
Has duplicate Redmine - Defect #19033: Filters that utilize date/time ignore ... Closed

2010-09-23

Associated revisions

Revision 15379 - 2016-05-07 12:42 - Jean-Philippe Lang

Replace Date.today with User.current.today (#22320).

Depending on the offset between a user's configured timezone and the server
timezone, Date.today may be more or less often wrong from the user's
perspective, leading to things like issues marked as overdue too early or too
late, or yesterday / tomorrow being displayed / selected where 'today' is
intended.

A test case illustrating the problem with Issue#overdue? is included

Patch by Jens Kraemer.

Revision 15381 - 2016-05-07 12:58 - Jean-Philippe Lang

Fixes Query#date_clause timezone handling (#22320).

When querying time fields based on date values these should be interpreted
in the user's time zone, since that's what a user usually expects.

Patch by Jens Kraemer.

Revision 15383 - 2016-05-07 13:06 - Jean-Philippe Lang
Simplify User#today (#22320).

Patch by Jens Kraemer.

Revision 15392 - 2016-05-07 20:30 - Jean-Philippe Lang
Test failure with SQLServer (#22320).

Revision 16938 - 2017-07-31 08:57 - Toshi MARUYAMA

try IssueTest#test_overdue failing on Cl server at Japanese daytime (#22320)

Revision 16951 - 2017-08-09 08:36 - Toshi MARUYAMA
https://plan.io/redmine-hosting
https://www.redmine.org/issues/20473

Merged r16938 from trunk to 3.4-stable (#22320)

try IssueTesti#test_overdue failing on Cl server at Japanese daytime.

Revision 16952 - 2017-08-09 08:38 - Toshi MARUYAMA
Merged r16938 from trunk to 3.3-stable (#22320)

try IssueTest#test_overdue failing on Cl server at Japanese daytime.

History

#1 - 2016-03-26 09:47 - Jan from Planio www.plan.io

- Target version set to Candidate for next minor release

#2 - 2016-03-26 10:29 - Jan from Planio www.plan.io

- Has duplicate Patch #20473: Respect the user's timezone when querying issues added

#3 - 2016-03-26 10:29 - Jan from Planio www.plan.io
- Has duplicate Defect #19033: Filters that utilize date/time ignore user's UTC offset added

#4 - 2016-03-27 06:07 - Jens Kramer
- File 0003-simplify-User-today.patch added

TimeZone actually has a today method, this patch changes User#today to use it.

#5 - 2016-04-08 15:28 - Jan from Planio www.plan.io
- Related to Defect #16482: Wrong search query for timelog, when timezone not UTC added

#6 - 2016-04-25 05:45 - Toshi MARUYAMA

- Target version changed from Candidate for next minor release to 3.3.0

#7 - 2016-05-07 13:07 - Jean-Philippe Lang
- Category set to 118n
- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

Committed, thanks.

#8 - 2016-06-29 18:16 - Jean-Philippe Lang
- Related to Defect #23189: Spent time by filter, offset by one day added

#9 - 2019-01-24 07:03 - Go MAEDA
- Related to Feature #6470: timezone adjust start/due date added

Files

0001-Replace-Date.today-with-User.current.today.patch 21.8 KB 2016-03-26 Jens Kramer
0002-Fixes-Query-date_clause-timezone-handling.patch 3.74 KB 2016-03-26 Jens Kramer
0003-simplify-User-today.patch 639 Bytes 2016-03-27 Jens Kramer
